#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "./header/extern.h"
#include "./header/define.h"
#define IPL_DEPTH_8U IPL_DEPTH_32F
int main(void){
//*****変数定義*****
	IplImage *input = 0;				//入力画像
	IplImage *input_gray = 0;			//入力画像グレー
	IplImage *input_niti = 0;			//入力画像二値化
	IplImage *input_edge = 0;			//入力画像cannyによるエッジ処理
	IplImage *input_rinkaku = 0;			//入力画像の輪郭検出
	IplImage *input_sikaku = 0;			//入力画像の輪郭検出→輪郭の矩形バージョン
	IplImage *output = 0;				//出力画像

	int Z=0;
	
	IplImage *cst[4];
	IplImage *cst_bw[4];
	//int Z=0;
	int M=0;					//出力番号
	int S=0;					//数字認識
	IplImage *cst1=0,*cst2=0,*cst3=0,*cst4 = 0;				//数字認識
	IplImage *cst1_bw=0,*cst2_bw=0,*cst3_bw=0,*cst4_bw = 0;				//数字認識
	
	/**********自動補正用***********/	
	int maku=30;					//上隠し部分の設定(最初は幕が降りている)
	int sikiti=100;				//二値化のしきい値設定(最初はしきい値高め。)
	int maku_count=0;
	int sikiti_count=0;
	int nextx=0;					//違う画像を取得している事を確認する。
	/**********輪郭検出用～***********/	
	CvMemStorage *storage = cvCreateMemStorage (0);
	CvSeq *contours = 0;
	int levels = 0;
	/**************矩形***************/
	CvRect rect[500];
	int i=0;
	int katayama=0;
 	double result[3];	
 	/**************左右の判別***************/			//三種類比較の結果

	/*********数字判断***********/
	int x,y,Sr,Sl;


/*****画像取得*****/

	/*ウェブカメラから画像取得～*/
	int c;
	IplImage *frame = 0;

	//カメラの初期化（カメラの選択）
	CvCapture *capture = cvCaptureFromCAM(0);

	//取込サイズの設定
	cvSetCaptureProperty (capture, CV_CAP_PROP_FRAME_WIDTH,  640);
	cvSetCaptureProperty (capture, CV_CAP_PROP_FRAME_HEIGHT, 480);

	//ウィンドウの表示
//	cvNamedWindow ("frame", CV_WINDOW_AUTOSIZE);
	
	     //フレーム画像の取込	
	     frame = cvQueryFrame (capture);
	               
	     //画像の表示
	//     cvShowImage ("frame", frame);	               

	cvSaveImage("./img/input.jpg",frame,NULL);

//後始末
//cvReleaseCapture (&capture);
//cvDestroyWindow ("frame");


	
	input = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);		//8bit_カラー入力画像
	input_gray = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYDEPTH);	//8bit_白黒入力画像
	input_niti = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYDEPTH);	//8bit_二値化入力画像(初期化)
	input_edge = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYDEPTH);	//8bit_二値化入力画像(初期化)
	input_rinkaku = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);	//8bit_二値化画像の輪郭検出(初期化)
	input_sikaku = cvLoadImage("./img/input.jpg", CV_LOAD_IMAGE_ANYCOLOR);	//8bit_二値化画像の輪郭の矩形バージョン検出(初期化)

 for(sikiti=180;sikiti>10;sikiti=sikiti-10){
 for(maku=100;maku>10;maku=maku-5){
 
/*******二値化******/
	cvThreshold(input_gray,input_niti,sikiti,255,CV_THRESH_BINARY | CV_THRESH_OTSU);

/**************エッジ検出***************/	
	//cvCanny(input_gray,input_edge,40,120,3);
	
/***************輪郭検出******************/
			cvRectangle (input_niti,
			cvPoint (0, 0),
			cvPoint (1000, maku),				/****幕の上下はここで行う！****/
			CV_RGB (0, 0, 0), CV_FILLED, 8, 0
			);
	cvNamedWindow("input_niti", CV_WINDOW_AUTOSIZE);
	cvShowImage("input_niti", input_niti);
katayama=cvFindContours (input_niti, storage, &contours, sizeof (CvContour), CV_RETR_LIST, CV_CHAIN_APPROX_SIMPLE,cvPoint(0, 0));
cvDrawContours (input_rinkaku, contours, CV_RGB (255, 0, 0), CV_RGB (0, 255, 0), levels + 1, 2, CV_AA, cvPoint (0, 0));

/****************矩形描画*************************/	
	for(i=0;i<(katayama);i++){
		rect[i] = cvBoundingRect (contours, 1);
		
		if((rect[i].width <= rect[i].height)/*&&((rect[i].width)*(rect[i].height))>600*/){
		if(rect[i].width>10 &&rect[i].height>10){	//ちっちゃい奴は要らねぇ(赤)
			cvRectangle (input_sikaku, cvPoint (rect[i].x, rect[i].y),cvPoint (rect[i].x + rect[i].width, rect[i].y + rect[i].height), CV_RGB (255, 0, 0), 1, 8, 0);

			if(	(					//x:y=2:3.5に近くない奴は要らねぇ!!(緑)
				(
				rect[i].height>((3.5/2)*(rect[i].width))-(rect[i].width/2.8))
				&&(rect[i].height<((3.5/2)*(rect[i].width))+(rect[i].width/2.5)
				)
				)
				||//条件"or"
				(					//"1"の形っぽい奴だけは例外だ！
				  (
				rect[i].height>((5)*(rect[i].width))-(rect[i].width*1.5))
				&&(rect[i].height<((5)*(rect[i].width))+(rect[i].width*1.5))				
				)
				){
				
				if((					//"1"の形っぽい奴なら2:3.5スケールにしてやるぜ！(比はおよそ6:1)
				(rect[i].height>((5)*(rect[i].width))-(rect[i].width*1.5))
				&&(rect[i].height<((5)*(rect[i].width))+(rect[i].width*1.5))				
				)){
					cvRectangle (input_sikaku,
					cvPoint ( ( (rect[i].x-(2.5)*rect[i].width)), rect[i].y),
					cvPoint (((rect[i].x)+(9/16)*rect[i].height+rect[i].width), rect[i].y + rect[i].height),
					CV_RGB (0, 0, 255), 2, 8, 0
				);
				
				
				}
				if((					//x:y=2:3.5に近い奴はそのままだ！
				(rect[i].height>((3.5/2)*(rect[i].width))-(rect[i].width))
				&&(rect[i].height<((3.5/2)*(rect[i].width))+(rect[i].width))				
				)){
					cvRectangle (input_sikaku,
					cvPoint (rect[i].x, rect[i].y),
					cvPoint (rect[i].x + rect[i].width, rect[i].y + rect[i].height),
					CV_RGB (0, 255, 0), 2, 8, 0
				);	
				
				}
				
				printf("/*********ヒット！%d回数目********/\n",maku_count);
				printf("x[%d]=%d\ny[%d]=%d\n",i,rect[i].x,i,rect[i].y);
				printf("width[%d]=%d\nheight[%d]=%d\n/***********************/\n",i,rect[i].width,i,rect[i].height);

				
/***********************画像の切り抜き*************************/
// inputに領域を指定後、コピーして領域をリセット


				cvSetImageROI(input, cvRect((rect[i].x)-(rect[i].width*0.1), (rect[i].y)-(rect[i].height*0.1), rect[i].width*1.2, rect[i].height*1.2));
				if(rect[i].x != nextx){printf("ヒットしてるよ！！！！！\n");
								maku_count++;

				if(Z==0){
					cvSaveImage("./img/out_l.jpg",input,NULL);
					cvSaveImage("./img/out_r.jpg",input,NULL);
					nextx = rect[i].x;
				Z++;}else if(Z==1){
					if(nextx < rect[i].x){		/*２枚めの画像の方が右にあったら**/
						cvSaveImage("./img/out_r.jpg",input,NULL);/*右を上書き*/
					}else{
						cvSaveImage("./img/out_l.jpg",input,NULL);/*左を上書き*/
						
					}
				Z++;}else if(Z==2){
					//cvSaveImage("./img/error.jpg",input,NULL);
				Z++;}else if(Z==3){
					//cvSaveImage("./img/error2.jpg",input,NULL);
				Z++;}

				}
				cvResetImageROI(input);
				if((Z >=2)||(maku_count>=2)){maku =0;sikiti=0;}
			}
		}
		}
		contours = contours->h_next;
	}
	printf("幕の下がり度%d\n",maku);
}			/**幕のループ**/

	printf("しきい値下がり度%d\n",sikiti);
}			/**幕のループ**/


/***************************数字認識開始*******************************/


//		cst[0] = cvBoundingRect (contours, 1);
//		cst[1] = cvBoundingRect (contours, 1);
	cst[0] = cvLoadImage("./img/out_l.jpg", CV_LOAD_IMAGE_ANYCOLOR);	
	cst[1] = cvLoadImage("./img/out_r.jpg", CV_LOAD_IMAGE_ANYCOLOR);
	
	cst_bw[0] = cvLoadImage("./img/out_l.jpg", CV_LOAD_IMAGE_ANYDEPTH);	//左の二値化画像
	cst_bw[1] = cvLoadImage("./img/out_r.jpg", CV_LOAD_IMAGE_ANYDEPTH);	//右の二値化画像

	cvThreshold(cst_bw[0],cst_bw[0],100,255,CV_THRESH_BINARY | CV_THRESH_OTSU);
	cvThreshold(cst_bw[1],cst_bw[1],100,255,CV_THRESH_BINARY | CV_THRESH_OTSU);

	int b;
	unsigned char p;

	p = cst_bw[M] -> imageData[cst_bw[M]->widthStep * y + x];
	b=(int)p;



/****************識別用変数置き場cst[0]用*************************/

//unsigned char V1=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/4  + 2*cst_bw[0]->width/9-4 ];
//int V1=(int)v1;
	uchar col,V1;
	int www;
	for(x = 0; x < cst_bw[0]->width/2; x++){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep * (3*cst_bw[0] -> height / 8) + x];
		www = col;
		if(www == 0 ){
			V1 = 0;
			break;
		}else{
			V1=255;
		}

	}

//unsigned char V2=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/16 + cst_bw[0]->width/2];
//int V2=(int)v2;

	uchar V2;
	for(y =0;y<= cst_bw[0]->height/4; y++){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep*y + (cst_bw[0]->width/2)];
		www = (int)col;
		if(www == 0){
			V2 = 0;
			break;
		}else{
			V2=255;
		}

	}

//unsigned char V3=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/4  + 7*cst_bw[0]->width/9 ];
//int V3=(int)v3;


	uchar V3;
	for(x = cst_bw[0]->width-1; x >= cst_bw[0]->width/2; x--){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep * (3*cst_bw[0] -> height / 8) + x];
		www = (int)col;
		if(www == 0){
			V3 = 0;
			break;
		}else{
			V3=255;
		}

	}

//unsigned char V4=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 3 * cst_bw[0] -> height/4  + 7*cst_bw[0]->width/9 ];
//int V4=(int)v4;

	uchar V4;
	for(x = cst_bw[0]->width-1; x >= cst_bw[0]->width/2; x--){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep * (cst_bw[0] -> height / 4*3) + x];
		www = (int)col;
		if(www == 0){
			V4 = 0;
			break;
		}else{
			V4=255;
		}

	}

//unsigned char V5=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 15* cst_bw[0] -> height/16  + cst_bw[0]->width/2 ];
/*高さを基準にして下からちょっといったところなのでちょっとマイナスしました*/
//int V5=(int)v5;
	uchar V5;
	for(y =cst_bw[0]->height-1;y>= (3*cst_bw[0]->height/4); y--){
		col = cst_bw[0]->imageData[(cst_bw[0]->widthStep) * y + (6*cst_bw[0]->width/10)];
		www = (int)col;
		if(www == 0){
			V5 = 0;
			break;
		}else{
			V5=255;
		}

	}
//unsigned char V6=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 3 * cst_bw[0] -> height/4  + 2*cst_bw[0]->width/9 -2];
//int V6=(int)v6;

	uchar V6;
	for(x = cst_bw[0]->width - cst_bw[0]->width; x <= cst_bw[0]->width/2; x++){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep * (3*cst_bw[0] -> height / 4) + x];
		www = (int)col;
		if(www == 0){
			V6 = 0;
			break;
		}else{
			V6=255;
		}

	}

//unsigned char V7=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * cst_bw[0] -> height/2  + cst_bw[0]->width/2 ];
//int V7=(int)v7;
//printf("cst_dw[%d] \n",M);

	uchar V7;
	for(y =cst_bw[0]->height/4;y<= 3*cst_bw[0]->height/4; y++){
		col = cst_bw[0]->imageData[cst_bw[0]->widthStep *y + (cst_bw[0]->width/2)];
		www = (int)col;
		if(www == 0){
			V7 = 0;
			break;
		}else{
			V7=255;
		}

	}

/*******************************************確認用画像**********************************************/


				cvRectangle (cst[0],			//V1
					cvPoint (2*cst[0]->width/9 -4-2,cst[0] -> height/4-2),
					cvPoint (2*cst[0]->width/9-4+2,cst[0] -> height/4 +2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V2
					cvPoint (  cst_bw[0]->width/2-2 ,cst_bw[0] -> height/14 -2),
					cvPoint (  cst_bw[0]->width/2+2 ,cst_bw[0] -> height/14 +2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V3
					cvPoint (7*cst_bw[0]->width/9-2+3,cst_bw[0] -> height/4-2),
					cvPoint (7*cst_bw[0]->width/9+2+3,cst_bw[0] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V4
					cvPoint (7*cst_bw[0]->width/9-2,3 * cst_bw[0] -> height/4-2),
					cvPoint (7*cst_bw[0]->width/9+2,3 * cst_bw[0] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V5
					cvPoint (cst_bw[0]->width/2-2,13* cst_bw[0]->height/14-2),
					cvPoint (cst_bw[0]->width/2+2,13* cst_bw[0]->height/14+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V6
					cvPoint (2*cst_bw[0]->width/9-2-2,3 * cst_bw[0] -> height/4-2),
					cvPoint (2*cst_bw[0]->width/9+2-2,3 * cst_bw[0] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[0],			//V7
					cvPoint (cst_bw[0]->width/2-2,5*cst_bw[0] -> height/10-2),
					cvPoint (cst_bw[0]->width/2+2,5*cst_bw[0] -> height/10+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);



/************************************認識用変数置き場****************************************/


//unsigned char V1=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/4  + 2*cst_bw[0]->width/9-4 ];
//int V1=(int)v1;
	uchar col2,V11;
	for(x = 0; x < cst_bw[1]->width/2; x++){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep * (cst_bw[1] -> height / 4) + x];
		www = col2;
		if(www == 0 ){
			V11 = 0;
			break;
		}else{
			V11=255;
		}

	}

//unsigned char V2=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/16 + cst_bw[0]->width/2];
//int V2=(int)v2;

	uchar V21;
	for(y =0;y<= cst_bw[1]->height/4; y++){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep*y + (cst_bw[1]->width/2)];
		www = (int)col2;
		if(www == 0){
			V21 = 0;
			break;
		}else{
			V21=255;
		}

	}

//unsigned char V3=cst_bw[0] -> imageData[cst_bw[0] -> widthStep *  cst_bw[0] -> height/4  + 7*cst_bw[0]->width/9 ];
//int V3=(int)v3;


	uchar V31;
	for(x = cst_bw[1]->width-1; x >= cst_bw[1]->width/2; x--){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep * (cst_bw[1] -> height / 4) + x];
		www = (int)col2;
		if(www == 0){
			V31 = 0;
			break;
		}else{
			V31=255;
		}

	}

//unsigned char V4=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 3 * cst_bw[0] -> height/4  + 7*cst_bw[0]->width/9 ];
//int V4=(int)v4;

	uchar V41;
	for(x = cst_bw[1]->width-1; x >= cst_bw[0]->width/2; x--){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep * (3*cst_bw[1] -> height / 4) + x];
		www = (int)col2;
		if(www == 0){
			V41 = 0;
			break;
		}else{
			V41=255;
		}

	}

//unsigned char V5=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 15* cst_bw[0] -> height/16  + cst_bw[0]->width/2 ];
/*高さを基準にして下からちょっといったところなのでちょっとマイナスしました*/
//int V5=(int)v5;
	uchar V51;
	for(y =(cst_bw[1]->height) -1;y>= 3*cst_bw[1]->height/4; y--){
		col2 = cst_bw[1]->imageData[ (cst_bw[1]->widthStep) * y + (6*cst_bw[1]->width/10)];
		www = (int)col2;
		if(www == 0){
			V51 = 0;
			break;
		}else{
			V51=255;
		}

	}
	
	
//unsigned char V6=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * 3 * cst_bw[0] -> height/4  + 2*cst_bw[0]->width/9 -2];
//int V6=(int)v6;

	uchar V61;
	for(x = cst_bw[1]->width - cst_bw[1]->width; x <= cst_bw[1]->width/2; x++){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep * (3*cst_bw[1] -> height / 4) + x];
		www = (int)col2;
		if(www == 0){
			V61 = 0;
			break;
		}else{
			V61=255;
		}

	}

//unsigned char V7=cst_bw[0] -> imageData[cst_bw[0] -> widthStep * cst_bw[0] -> height/2  + cst_bw[0]->width/2 ];
//int V7=(int)v7;
//printf("cst_dw[%d] \n",M);

	uchar V71;
	for(y =cst_bw[1]->height/4;y<= 3*cst_bw[1]->height/4; y++){
		col2 = cst_bw[1]->imageData[cst_bw[1]->widthStep *y + (cst_bw[1]->width/2)];
		www = (int)col2;
		if(www == 0){
			V71 = 0;
			break;
		}else{
			V71=255;
		}

	}














/****************識別用変数置き場cst[1]************************

unsigned char v11=cst_bw[1] -> imageData[cst_bw[1] -> widthStep *  cst_bw[1] -> height/4  + 2*cst_bw[1]->width*cst_bw[1]->nChannels/9-4 ];
int V11=(int)v11;

unsigned char v21=cst_bw[1] -> imageData[cst_bw[1] -> widthStep *  cst_bw[1] -> height/14  + cst_bw[1]->width*cst_bw[1]->nChannels/2];
int V21=(int)v21;

unsigned char v31=cst_bw[1] -> imageData[cst_bw[1] -> widthStep *  cst_bw[1] -> height/4  + 7*cst_bw[1]->width*cst_bw[1]->nChannels/8+3 ];
int V31=(int)v31;

unsigned char v41=cst_bw[1] -> imageData[cst_bw[1]->widthStep * 3*cst_bw[1] -> height/4  + 7*cst_bw[1]->width*cst_bw[1]->nChannels/9 ];
int V41=(int)v41;

unsigned char v51=cst_bw[1] -> imageData[cst_bw[1] -> widthStep * 13* cst_bw[1] -> height/14  + cst_bw[1]->width*cst_bw[1]->nChannels/2 ];
/*高さを基準にして下からちょっといったところなのでちょっとマイナスしました
int V51=(int)v51;

unsigned char v61=cst_bw[1] -> imageData[cst_bw[1] -> widthStep * 3 * cst_bw[1] -> height/4  + 2*cst_bw[1]->width*cst_bw[1]->nChannels/9 -2];
int V61=(int)v61;

unsigned char v71=cst_bw[1] -> imageData[cst_bw[1] -> widthStep * 5*cst_bw[1] -> height/10  + cst_bw[1]->width*cst_bw[1]->nChannels/2 ];
int V71=(int)v71;

*/
/*******************************************確認用画像**********************************************/
				cvRectangle (cst[1],			//V1
					cvPoint (2*cst[1]->width/9 -4-2,cst[1] -> height/4-2),
					cvPoint (2*cst[1]->width/9+2-4,cst[1] -> height/4 +2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V2
					cvPoint (  cst_bw[1]->width/2-2 ,cst_bw[1] -> height/14 -2),
					cvPoint (  cst_bw[1]->width/2+2 ,cst_bw[1] -> height/14 +2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V3
					cvPoint (7*cst_bw[1]->width/8-2+3,cst_bw[1] -> height/4-2),
					cvPoint (7*cst_bw[1]->width/8+2+3,cst_bw[1] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V4
					cvPoint (7*cst_bw[1]->width/9-2,3 * cst_bw[1] -> height/4-2),
					cvPoint (7*cst_bw[1]->width/9+2,3 * cst_bw[1] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V5
					cvPoint (cst_bw[1]->width/2-2,13* cst_bw[1]->height/14-2),
					cvPoint (cst_bw[1]->width/2+2,13* cst_bw[1]->height/14+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V6
					cvPoint (2*cst_bw[1]->width/9-2-2,3 * cst_bw[1] -> height/4-2),
					cvPoint (2*cst_bw[1]->width/9+2-2,3 * cst_bw[1] -> height/4+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);

				cvRectangle (cst[1],			//V7
					cvPoint (cst_bw[1]->width/2-2,5*cst_bw[1] -> height/10-2),
					cvPoint (cst_bw[1]->width/2+2,5*cst_bw[1] -> height/10+2),
					CV_RGB (0, 255, 0), CV_FILLED, 8, 0
				);











/*
unsigned char v1=cst_bw[M] -> imageData[cst_bw[M] -> widthStep *  cst_bw[M] -> height/4  + cst_bw[M]->width/6 ];
int V1=(int)v1;

unsigned char v2=cst_bw[M] -> imageData[cst_bw[M] -> widthStep *  cst_bw[M] -> height/12  + cst_bw[M]->width/2];
int V2=(int)v2;

unsigned char v3=cst_bw[M] -> imageData[cst_bw[M] -> widthStep *  cst_bw[M] -> height/4  + 5*cst_bw[M]->width/6 ];
int V3=(int)v3;

unsigned char v4=cst_bw[M] -> imageData[cst_bw[M] -> widthStep * 3 * cst_bw[M] -> height/4  + 5*cst_bw[M]->width/6 ];
int V4=(int)v4;

unsigned char v5=cst_bw[M] -> imageData[cst_bw[M] -> widthStep * 11* cst_bw[M] -> height/12  + cst_bw[M]->width/2 ];
int V5=(int)v5;

unsigned char v6=cst_bw[M] -> imageData[cst_bw[M] -> widthStep * 3 * cst_bw[M] -> height/4  + cst_bw[M]->width/6 ];
int V6=(int)v6;

unsigned char v7=cst_bw[M] -> imageData[cst_bw[M] -> widthStep *  cst_bw[M] -> height/2  + cst_bw[M]->width/2 ];
int V7=(int)v7;
*/





printf("left\n");

printf("V1=%d \n",V1);
printf("V2=%d \n",V2);
printf("V3=%d \n",V3);
printf("V4=%d \n",V4);
printf("V5=%d \n",V5);
printf("V6=%d \n",V6);
printf("V7=%d \n",V7);

printf("right\n");

printf("V11=%d \n",V11);
printf("V21=%d \n",V21);
printf("V31=%d \n",V31);
printf("V41=%d \n",V41);
printf("V51=%d \n",V51);
printf("V61=%d \n",V61);
printf("V71=%d \n",V71);


	if(							//1の識別
	( rect[i].height > ( (5) * (rect[i].width) ) - (rect[i].width*1.5))
	&&
	( rect[i].height < ( (5) * (rect[i].width) ) + (rect[i].width*1.5))
	){		
		Sl=1;
		printf("不肖MIRS!!左のDBの数字は1かと愚考いたします! \n");
	}else if(						//2の識別
		 V1==255
	&&	 V2==0
	&&	 V3==0
	&&	 V4==255
	&&	 V5==0
	&&	 V6==0
	&&	 V7==0){
		Sl=2;
		if(M<3){M++;}
		printf("不肖MIRS!!左のDBの数字は2かと愚考いたします! \n");
	}else if(					//3の識別	
		 V1==255
	&&	 V2==0
	&&	 V3==0
	&&	 V4==0
	&&	 V5==0
	&&	 V6==255
	&&	 V7==0){
		Sl=3;
		if(M<3){M++;}
		printf("不肖MIRS!!左のDBの数字は3かと愚考いたします! \n");
	}else if(
		 V1==0					//4の識別	
	&&	 V2==255
	&&	 V3==0
	&&	 V4==0
	&&	 V5==255
	&&	 V6==255
	&&	 V7==0){
		Sl=4;
		if(M<3){M++;}
		printf("不肖MIRS!!左のDBの数字は4かと愚考いたします! \n");
	}else if(	
		V1==0
	&&	V2==0				//5の識別	
	&&	V3==255
	&&	V4==0
	&&	V5==0
	&&	V6==255
	&&	V7==0){
		Sl=5;
		if(M<3){M++;}
		printf("不肖MIRS!!左のDBの数字は5かと愚考いたします! \n");
	}else if(
		V1==0
	&&	V2==0
	&&	V3==0	
	&&	V4==0
	&&	V5==0
	&&	V6==0						//0の識別	
	&&	V7==255){
		Sl=0;
		if(M<3){M++;}
		printf("不肖MIRS!!左のDBの数字は0かと愚考いたします! \n");
	}else{
		printf("たかだか左の数字すら読めぬ己れの無能さ、申し開きの仕様もありませぬ。\n");
		if(M<3){M++;}
}

	



/******************************************右***************************************************/
	if(							//1の識別
	( rect[i].height > ( (5) * (rect[i].width) ) - (rect[i].width*1.5))
	&&
	( rect[i].height < ( (5) * (rect[i].width) ) + (rect[i].width*1.5))
	){		
		Sr=1;
		printf("不肖MIRS!!右のDBの数字は1かと愚考いたします! \n");
	}else if(						//2の識別
		 V11==255
	&&	 V21==0
	&&	 V31==0
	&&	 V41==255
	&&	 V51==0
	&&	 V61==0
	&&	 V71==0){
		Sr=2;
		if(M<3){M++;}
		printf("不肖MIRS!!右のDBの数字は2かと愚考いたします! \n");
	}else if(					//3の識別	
		 V11==255
	&&	 V21==0
	&&	 V31==0
	&&	 V41==0
	&&	 V51==0
	&&	 V61==255
	&&	 V71==0){
		Sr=3;
		if(M<3){M++;}
		printf("不肖MIRS!!右のDBの数字は3かと愚考いたします! \n");
	}else if(
		 V11==0					//4の識別	
	&&	 V21==255
	&&	 V31==0
	&&	 V41==0
	&&	 V51==255
	&&	 V61==255
	&&	 V71==0){
		Sr=4;
		if(M<3){M++;}
		printf("不肖MIRS!!右のDBの数字は4かと愚考いたします! \n");
	}else if(	
		V11==0
	&&	V21==0				//5の識別	
	&&	V31==255
	&&	V41==0
	&&	V51==0
	&&	V61==255
	&&	V71==0){
		Sr=5;
		if(M<3){M++;}
		printf("不肖MIRS!!右のDBの数字は5かと愚考いたします! \n");
	}else if(
		V11==0
	&&	V21==0
	&&	V31==0	
	&&	V41==0
	&&	V51==0
	&&	V61==0						//0の識別	
	&&	V71==255){
		Sr=0;
		if(M<3){M++;}
		printf("不肖MIRS!!右のDBの数字は0かと愚考いたします! \n");
	}else{
		printf("たかだか右の数字すら読めぬ己れの無能さ、申し開きの仕様もありませぬ。\n");
		if(M<3){M++;}
}
//元画像
//	cvNamedWindow("input", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input", input);

//	cvNamedWindow("input_gray", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input_gray", input_gray);
	


//	cvNamedWindow("input_edge", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input_edge", input_edge);
	
//	cvNamedWindow("input_rinkaku", CV_WINDOW_AUTOSIZE);
//	cvShowImage("input_rinkaku", input_rinkaku);

	cvNamedWindow("input_sikaku", CV_WINDOW_AUTOSIZE);
	cvShowImage("input_sikaku", input_sikaku);

	cvNamedWindow("cst[0]", CV_WINDOW_AUTOSIZE);
	cvShowImage("cst[0]", cst[0]);


	cvNamedWindow("cstbw[0]", CV_WINDOW_AUTOSIZE);
	cvShowImage("cstbw[0]", cst_bw[0]);

	cvNamedWindow("cst[1]", CV_WINDOW_AUTOSIZE);
	cvShowImage("cst[1]", cst[1]);


	cvNamedWindow("cstbw[1]", CV_WINDOW_AUTOSIZE);
	cvShowImage("cstbw[1]", cst_bw[1]);




	cvWaitKey(0);



}
